"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

from abc import (
    ABCMeta,
    abstractmethod,
)
from chalk._gen.chalk.server.v1.builder_pb2 import (
    ActivateDeploymentRequest,
    ActivateDeploymentResponse,
    CreateClusterBackgroundPersistenceRequest,
    CreateClusterBackgroundPersistenceResponse,
    CreateClusterGatewayRequest,
    CreateClusterGatewayResponse,
    CreateClusterTimescaleDBRequest,
    CreateClusterTimescaleDBResponse,
    DeployKubeComponentsRequest,
    DeployKubeComponentsResponse,
    GetClusterBackgroundPersistenceRequest,
    GetClusterBackgroundPersistenceResponse,
    GetClusterGatewayRequest,
    GetClusterGatewayResponse,
    GetClusterTimescaleDBRequest,
    GetClusterTimescaleDBResponse,
    GetDeploymentLogsRequest,
    GetDeploymentLogsResponse,
    GetDeploymentStepsRequest,
    GetDeploymentStepsResponse,
    GetSearchConfigRequest,
    GetSearchConfigResponse,
    IndexDeploymentRequest,
    IndexDeploymentResponse,
    MigrateClusterTimescaleDBRequest,
    MigrateClusterTimescaleDBResponse,
    RebuildDeploymentRequest,
    RebuildDeploymentResponse,
    RedeployDeploymentRequest,
    RedeployDeploymentResponse,
    StartBranchRequest,
    StartBranchResponse,
    UpdateEnvironmentVariablesRequest,
    UpdateEnvironmentVariablesResponse,
    UploadSourceRequest,
    UploadSourceResponse,
)
from grpc import (
    Channel,
    Server,
    ServicerContext,
    UnaryUnaryMultiCallable,
)

class BuilderServiceStub:
    def __init__(self, channel: Channel) -> None: ...
    GetSearchConfig: UnaryUnaryMultiCallable[
        GetSearchConfigRequest,
        GetSearchConfigResponse,
    ]
    ActivateDeployment: UnaryUnaryMultiCallable[
        ActivateDeploymentRequest,
        ActivateDeploymentResponse,
    ]
    """Takes an existing (past) deployment and promotes the k8s resources / other things associated with it.
    Useful for debugging in local development where the auto activation doesn't work b/c no pubsub.
    """
    IndexDeployment: UnaryUnaryMultiCallable[
        IndexDeploymentRequest,
        IndexDeploymentResponse,
    ]
    DeployKubeComponents: UnaryUnaryMultiCallable[
        DeployKubeComponentsRequest,
        DeployKubeComponentsResponse,
    ]
    """Intermediate step in the deployment activation process. Allows for partial migration to the new
    go-api-server builder service.
    """
    RebuildDeployment: UnaryUnaryMultiCallable[
        RebuildDeploymentRequest,
        RebuildDeploymentResponse,
    ]
    """Takes an existing (past) deployment and re-creates the image associated with it,
    publishing the image as 'new_image_tag'.
    """
    RedeployDeployment: UnaryUnaryMultiCallable[
        RedeployDeploymentRequest,
        RedeployDeploymentResponse,
    ]
    """Triggers a new build with the source code from this deployment and deploys the result"""
    UploadSource: UnaryUnaryMultiCallable[
        UploadSourceRequest,
        UploadSourceResponse,
    ]
    """Triggers a new build with the provided source code archive and deploys the result"""
    GetDeploymentSteps: UnaryUnaryMultiCallable[
        GetDeploymentStepsRequest,
        GetDeploymentStepsResponse,
    ]
    GetDeploymentLogs: UnaryUnaryMultiCallable[
        GetDeploymentLogsRequest,
        GetDeploymentLogsResponse,
    ]
    GetClusterTimescaleDB: UnaryUnaryMultiCallable[
        GetClusterTimescaleDBRequest,
        GetClusterTimescaleDBResponse,
    ]
    GetClusterGateway: UnaryUnaryMultiCallable[
        GetClusterGatewayRequest,
        GetClusterGatewayResponse,
    ]
    GetClusterBackgroundPersistence: UnaryUnaryMultiCallable[
        GetClusterBackgroundPersistenceRequest,
        GetClusterBackgroundPersistenceResponse,
    ]
    CreateClusterTimescaleDB: UnaryUnaryMultiCallable[
        CreateClusterTimescaleDBRequest,
        CreateClusterTimescaleDBResponse,
    ]
    MigrateClusterTimescaleDB: UnaryUnaryMultiCallable[
        MigrateClusterTimescaleDBRequest,
        MigrateClusterTimescaleDBResponse,
    ]
    CreateClusterGateway: UnaryUnaryMultiCallable[
        CreateClusterGatewayRequest,
        CreateClusterGatewayResponse,
    ]
    CreateClusterBackgroundPersistence: UnaryUnaryMultiCallable[
        CreateClusterBackgroundPersistenceRequest,
        CreateClusterBackgroundPersistenceResponse,
    ]
    UpdateEnvironmentVariables: UnaryUnaryMultiCallable[
        UpdateEnvironmentVariablesRequest,
        UpdateEnvironmentVariablesResponse,
    ]
    StartBranch: UnaryUnaryMultiCallable[
        StartBranchRequest,
        StartBranchResponse,
    ]

class BuilderServiceServicer(metaclass=ABCMeta):
    @abstractmethod
    def GetSearchConfig(
        self,
        request: GetSearchConfigRequest,
        context: ServicerContext,
    ) -> GetSearchConfigResponse: ...
    @abstractmethod
    def ActivateDeployment(
        self,
        request: ActivateDeploymentRequest,
        context: ServicerContext,
    ) -> ActivateDeploymentResponse:
        """Takes an existing (past) deployment and promotes the k8s resources / other things associated with it.
        Useful for debugging in local development where the auto activation doesn't work b/c no pubsub.
        """
    @abstractmethod
    def IndexDeployment(
        self,
        request: IndexDeploymentRequest,
        context: ServicerContext,
    ) -> IndexDeploymentResponse: ...
    @abstractmethod
    def DeployKubeComponents(
        self,
        request: DeployKubeComponentsRequest,
        context: ServicerContext,
    ) -> DeployKubeComponentsResponse:
        """Intermediate step in the deployment activation process. Allows for partial migration to the new
        go-api-server builder service.
        """
    @abstractmethod
    def RebuildDeployment(
        self,
        request: RebuildDeploymentRequest,
        context: ServicerContext,
    ) -> RebuildDeploymentResponse:
        """Takes an existing (past) deployment and re-creates the image associated with it,
        publishing the image as 'new_image_tag'.
        """
    @abstractmethod
    def RedeployDeployment(
        self,
        request: RedeployDeploymentRequest,
        context: ServicerContext,
    ) -> RedeployDeploymentResponse:
        """Triggers a new build with the source code from this deployment and deploys the result"""
    @abstractmethod
    def UploadSource(
        self,
        request: UploadSourceRequest,
        context: ServicerContext,
    ) -> UploadSourceResponse:
        """Triggers a new build with the provided source code archive and deploys the result"""
    @abstractmethod
    def GetDeploymentSteps(
        self,
        request: GetDeploymentStepsRequest,
        context: ServicerContext,
    ) -> GetDeploymentStepsResponse: ...
    @abstractmethod
    def GetDeploymentLogs(
        self,
        request: GetDeploymentLogsRequest,
        context: ServicerContext,
    ) -> GetDeploymentLogsResponse: ...
    @abstractmethod
    def GetClusterTimescaleDB(
        self,
        request: GetClusterTimescaleDBRequest,
        context: ServicerContext,
    ) -> GetClusterTimescaleDBResponse: ...
    @abstractmethod
    def GetClusterGateway(
        self,
        request: GetClusterGatewayRequest,
        context: ServicerContext,
    ) -> GetClusterGatewayResponse: ...
    @abstractmethod
    def GetClusterBackgroundPersistence(
        self,
        request: GetClusterBackgroundPersistenceRequest,
        context: ServicerContext,
    ) -> GetClusterBackgroundPersistenceResponse: ...
    @abstractmethod
    def CreateClusterTimescaleDB(
        self,
        request: CreateClusterTimescaleDBRequest,
        context: ServicerContext,
    ) -> CreateClusterTimescaleDBResponse: ...
    @abstractmethod
    def MigrateClusterTimescaleDB(
        self,
        request: MigrateClusterTimescaleDBRequest,
        context: ServicerContext,
    ) -> MigrateClusterTimescaleDBResponse: ...
    @abstractmethod
    def CreateClusterGateway(
        self,
        request: CreateClusterGatewayRequest,
        context: ServicerContext,
    ) -> CreateClusterGatewayResponse: ...
    @abstractmethod
    def CreateClusterBackgroundPersistence(
        self,
        request: CreateClusterBackgroundPersistenceRequest,
        context: ServicerContext,
    ) -> CreateClusterBackgroundPersistenceResponse: ...
    @abstractmethod
    def UpdateEnvironmentVariables(
        self,
        request: UpdateEnvironmentVariablesRequest,
        context: ServicerContext,
    ) -> UpdateEnvironmentVariablesResponse: ...
    @abstractmethod
    def StartBranch(
        self,
        request: StartBranchRequest,
        context: ServicerContext,
    ) -> StartBranchResponse: ...

def add_BuilderServiceServicer_to_server(servicer: BuilderServiceServicer, server: Server) -> None: ...
